'-------------------------------------------------------------------------------
'UNO_Timer3.BAS  B1 Fout 250 Hz...4 MHz
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600
$hwstack = 16                                               '8
$swstack = 16                                               '4
$framesize = 16                                             '4

Dim D As Long
Dim F As Long
Dim N As Byte

S1 Alias Pinc.0
S2 Alias Pinc.1
Portc.0 = 1                                                 'Pullup
Portc.1 = 1                                                 'Pullup

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cls
Cursor Off

Config Timer1 = Pwm , Prescale = 1 , Pwm = 10 , Compare A Pwm = Clear Up

Tccr1a = &B10000010                                         'Phase-correct PWM, Top=ICR1
Tccr1b = &B00010001                                         'Prescaler=1

D = 8000
Do
  N = Ischarwaiting()
  If N = 1 Then
    Input F
    D = 8000000 / F
    If D > 64000 Then D = 64000
    If D < 2 Then D = 2
  End If
  If S1 = 0 Then
    D = D + 1
    If D > 100 Then D = D + 1
    If D > 1000 Then D = D + 100
    If D > 10000 Then D = D + 1000
    If D > 64000 Then D = 64000
  End If
  If S2 = 0 Then
    If D > 2 Then D = D - 1
    If D > 100 Then D = D - 10
    If D > 1000 Then D = D - 100
    If D > 10000 Then D = D - 1000
    If D > 64000 Then D = 64000
  End If
  Locate 1 , 1
  F = 16000000 / D
  F = F / 2
  Lcd F
  Lcd " Hz      "
  Icr1 = D
  Ocr1a = D / 2
  Waitms 50
Loop