'-------------------------------------------------------------------------------
'UNO_Display.BAS  COM input B0
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$hwstack = 16
$swstack = 16
$framesize = 64
$baud = 9600

Dim Text1 As String * 16
Dim Text2 As String * 16

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cls
Cursor Off
'Open "comb.0:9600,8,n,1" For Input As #2                    'Software COM input at B0

Config Portb.0 = Input                                      'Arduino Pin 9
Portb.0 = 1                                                 'Pullup einschalten fr Tachoimpulse

Dim T As Word
Dim F As Word

Do
  Do
  Loop Until Pinb.0 = 0                                     'Messung der Dauer fr eine Umdrehung, zwei Impulse
  Do
  Loop Until Pinb.0 = 1                                     'Steigende Flanke abwarten
  T = 0
  Do
    T = T + 1
    Waitms 1
  Loop Until Pinb.0 = 0
  Do
    T = T + 1
    Waitms 1
  Loop Until Pinb.0 = 1                                     'Ende erster Impuls
  Do
    T = T + 1
    Waitms 1
  Loop Until Pinb.0 = 0
  Do
    T = T + 1
    Waitms 1
  Loop Until Pinb.0 = 1                                     'Ende zweiter Impuls



  Locate 1 , 1
  Lcd T;
  Lcd " ms   "

  Locate 2 , 1

  F = 60000 / T
  Lcd F
  Lcd " U/min "


  Waitms 500
Loop

End